// Written by TeTeT


ttt_amp_kf_fnc_parkingFree = {
	params ["_carrier", "_pos", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];
	private _planeSize = 6; // wingspan roughly, wings folded

	private _poly = [
		_pos getPos [_planeSize, getDir _carrier + 120],
		_pos getPos [_planeSize, getDir _carrier + 210],
		_pos getPos [_planeSize, getDir _carrier + 300],
		_pos getPos [_planeSize, getDir _carrier + 30]
	];

	private _ret = true;

	{
		if ( (getPosASL _x) # 2 - (getPosASL _carrier) # 2 < 20 and 
			getPosASL _x inPolygon _poly and 
			not (toLower typeOf _x in _excludeList) ) then {
				systemChat format ["%3 - In the way: %1", _x, typeOf _x];
				_ret = false;
		};
	// probably want to cache that nearEntities call
	} forEach (_carrier nearEntities [["Air", "Land", "Ship"], 200]);
	_ret;
};

ttt_amp_kf_fnc_parkFinal = {
	// if (true) exitWith {systemChat "abort"};

	_this spawn {
			params ["_timeline"];
		private _carrier = _timeline getVariable "ttt_amp_carrier";
		private _plane = _timeline getVariable "ttt_amp_parkingPlane";
		private _pp = _timeline getVariable "ttt_amp_parkingPos";
		private _ppPrepVectorDir = [vectorDir _carrier select 1, (vectorDir _carrier select 0) * -1, 0];

		private _finalDir = [vectorDir _carrier, -120, 0] call BIS_fnc_rotateVector3D;
		// needs to be more elegant
		while {abs(getDir _plane - (getDir _carrier + 90)) > 1} do {
			_plane setDir (getDir _plane + 0.2);
			sleep 0.05;
		};
		_plane setDir (getDir _carrier + 90);

		private _keysData = [
			[	
				0,
				getPosASL _plane,
				[
					(vectorDir _plane) vectorMultiply -1,
					[0,0,1]
				],
				[
					["Time", 0],
					["LeaveTangent", (vectorDir _plane) vectorMultiply -1],
					["LeaveTangentWeight", 100],
					["InterpMode", 0]
				]
			],
			[
				1,
				_pp,
				[
					vectorDir _plane,
					[0,0,1]
				],
				[
					["Time", 20],
					["ArriveTangent", vectorDir _plane],
					["ArriveTangentWeight", 0],
					["InterpMode", 0]
				]
			]
		];

		private _timelineData     = [ // Timeline variables
		    ["Length", 20],
		    ["Loop", false],
			["InterpMode", 0],
			["EventFinished", "_this call ttt_amp_kf_fnc_dirFinal"]
		];

		private _curvesData = [
		    [ // curve1
		    	[_plane], // vehicles
		        [ // Curve variables
		            ["OrientationMode", 0],
		            ["TimeInSeconds", true]
		        ],
		        _keysData
		    ]
		];

		private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
		if (isNull _group) then {
			_group = createGroup [sideLogic, true];
			_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
		};

		_timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
		_timeline setVariable ["ttt_amp_carrier", _carrier];
		_timeline setVariable ["ttt_amp_parkingPlane", _plane];
		_timeline setVariable ["ttt_amp_parkingPos", _pp];
		[_timeline] call BIS_fnc_timeline_play;

		_timeline
	};
};

ttt_amp_kf_fnc_dirFinal = {
	params ["_timeline"];

	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_parkingPlane";
	private _pp = _timeline getVariable "ttt_amp_parkingPos";

	[_plane, _carrier] spawn {
		params ["_plane", "_carrier"];
		// needs to be more elegant
		while {abs(getDir _plane - (getDir _carrier + 120)) > 1} do {
			_plane setDir (getDir _plane + 0.2);
			sleep 0.05;
		};
		_plane setDir (getDir _carrier + 120);
		_plane animateSource ["wheel_rot_source", 0, true];
		// TODO: force to get out and despawn
		deleteVehicleCrew _plane;
	};
	[_carrier, tractor_1, cart_1, _pp] spawn ttt_amp_kf_fnc_disarmPlane;
};

player addAction [
	"Park Plane",
	"[Nimitz, F18] call ttt_fnc_parking"
];


ttt_fnc_parking = {
	params ["_carrier", "_plane"];
	_plane engineOn true;
	createVehicleCrew _plane;

	private _pps = _carrier getVariable "ttt_nimitz_parkingPositions";
	private _freePPs = _pps select {[_carrier, _x] call ttt_amp_kf_fnc_parkingFree};

	systemChat format ["Found %1 free parking positions", count _freePPs];

	if (count _freePPs == 0) exitWith {
		"No free parking position" call bis_fnc_error;
	};

	[_plane , 1] call ttt_amp_kf_fnc_f18_wingfold;

	private _pp = selectRandom _freePPs;
	private _ppPrep = _pp getPos [15, getDir _carrier + 90];
	_ppPrep set [2, (getPosASL _carrier select 2) + 17.441];
	private _c1ss = [_carrier, "C1_shuttle_start"] call ttt_amp_kf_fnc_getMemPointNimitz;

	systemChat format ["Found a positon, taxiing to %1 via C1_shuttle_start", _pp];

	private _keysData = [
		// Tried to turn the plane around, didn't look nice
		[	
			0,
			getPosASL _plane,
			[
				vectorDir _plane,
				[0,0,1]
			],
			[
				["Time", 0],
				["LeaveTangent", vectorDir _plane],
				["LeaveTangentWeight", 100],
				["InterpMode", 1]
			]
		],
		[
			1,
			_c1ss,
			[
				vectorDir _carrier,
				[0,0,1]
			],
			[
				["Time", 20],
				["ArriveTangent", (vectorDir _carrier) vectorMultiply -1],
				["ArriveTangentWeight", 100],
				["InterpMode", 1]
			]
		],
		[
			2,
			_ppPrep,
			[
				vectorDir _carrier,
				[0,0,1]
			],
			[
				["Time", 40],
				["ArriveTangent", (vectorDir _carrier) vectorMultiply -1],
				["ArriveTangentWeight", 100],
				["InterpMode", 1]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", 40],
	    ["Loop", false],
		["InterpMode", 0],
		["EventFinished", "_this call ttt_amp_kf_fnc_parkFinal"]
	];

	private _curvesData = [
	    [ // curve1
	    	[_plane], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 3],
	            ["TimeInSeconds", true]
	        ],
	        _keysData
	    ]
	];

	private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
	if (isNull _group) then {
		_group = createGroup [sideLogic, true];
		_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
	};

	private _timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
	_timeline setVariable ["ttt_amp_carrier", _carrier];
	_timeline setVariable ["ttt_amp_parkingPlane", _plane];
	_timeline setVariable ["ttt_amp_parkingPos", _pp];
	[_timeline] call BIS_fnc_timeline_play;
	_plane animateSource ["wheel_rot_source", 1e12];
	_timeline
};

[Nimitz] spawn {
	params ["_carrier"];
	sleep 1;

	private _parkingEnd = [_carrier, "C2T"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_parkingEnd = _parkingEnd getPos [1, getDir _carrier - 90];
	_parkingEnd set [2, (getPosASL _carrier select 2) + 17.441];
	private _parkingStart = [_carrier, "C2"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_parkingStart = _parkingStart getPos [2, getDir _carrier - 90];
	_parkingStart set [2, (getPosASL _carrier select 2) + 17.441];


	private _parkingPos = _parkingEnd;
	private _parkingPositions = [];
	private _planes = [];
	while {_parkingPos distance _parkingStart > 25} do {
		_parkingPositions pushBack _parkingPos;
		private _plane = createVehicle ["JS_JC_FA18E", _parkingPos, [], 0, "NONE"];
		_planes pushBack _plane;
		[_plane, 1] call ttt_amp_kf_fnc_f18_wingfold;
		_plane setPosASL _parkingPos;
		_plane setDir (getDir _carrier + 120);
		_parkingPos = _parkingPos getPos [-13, getDir _carrier];
		_parkingPos set [2, (getPosASL _carrier select 2) + 17.441];
		sleep 0.1;
	};
	deleteVehicle selectRandom _planes;
	_carrier setVariable ["ttt_nimitz_parkingPositions", _parkingPositions];
};

// [Nimitz, tractor_1, cart_1] spawn {


ttt_amp_kf_fnc_disarmPlane = {
	params ["_carrier", "_tractor", "_cart", "_pp"];

	{
		_cart animateSource [_x, 1, true];
	} foreach ["m1", "m2", "m3", "m4", "m5", "m6", "m7", "m8"];
	
	// LESH_AxisOffsetTower[] = {0.4,-2,-0.8};
	_cart attachTo [_tractor, [0.35, -3.4, 0.6]];
	_cart setDir -180;
	_tractor setVariable ["ttt_amp_startPos", getPosASL _tractor];

	private _weaponsElevator = [_carrier, "E5Top"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_weaponsElevator = _weaponsElevator getPos [5, getDir _carrier];
	_weaponsElevator set [2, (getPosASL _carrier select 2) + 17.441];

	private _turnPoint = _weaponsElevator getPos [25, getDir _carrier - 45];
	_turnPoint set [2, (getPosASL _carrier select 2) + 17.441];
	private _turnPointArriveVector = _weaponsElevator vectorFromTo _turnPoint;
	private _turnPointLeaveVector = vectorDir _carrier;

	sleep 5;

	// private _pp = selectRandom (_carrier getVariable "ttt_nimitz_parkingPositions");
	private _ammoPos = _pp getPos [10, getDir _carrier + 90];
	_ammoPos set [2, (getPosASL _carrier select 2) + 17.441];

	private _time_1 = (_tractor distance _weaponsElevator) / 3;
	private _time_2 = _time_1 + (_weaponsElevator distance _turnPoint) / 3;
	private _time_3 = _time_1 + _time_2	+ (_turnPoint distance _ammoPos) / 3;
	private _keysData = [
		[	
			0,
			getPosASL _tractor,
			[
				vectorDir _tractor,
				[0,0,1]
			],
			[
				["Time", 0],
				["LeaveTangent", vectorDir _tractor],
				["LeaveTangentWeight", 100],
				["InterpMode", 0]
			]
		],
		[
			1,
			_weaponsElevator,
			[
				[vectorDir _carrier, 45, 2] call BIS_fnc_rotateVector3D,
				[0,0,1]
			],
			[
				["Time", _time_1],
				["ArriveTangent", [vectorDir _carrier, 45, 2] call BIS_fnc_rotateVector3D],
				["ArriveTangentWeight", 50],
				["LeaveTangent", _turnPointArriveVector],
				["LeaveTangentWeight", 50],
				["InterpMode", 1]
			]
		],
		[
			2,
			_turnPoint,
			[
				vectorDir _carrier,
				[0,0,1]
			],
			[
				["Time", _time_2],
				// ["ArriveTangent", vectorDir _carrier],
				// ["ArriveTangentWeight", 50],
				["LeaveTangent", _turnPointLeaveVector],
				["LeaveTangentWeight", 50],
				["InterpMode", 1]
			]
		],
		[
			3,
			_ammoPos,
			[
				vectorDir _carrier,
				[0,0,1]
			],
			[
				["Time", _time_3],
				["ArriveTangent", (vectorDir _carrier) vectorMultiply -1],
				["ArriveTangentWeight", 100],
				["InterpMode", 1]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", _time_3],
	    ["Loop", false],
		["InterpMode", 0],
		["EventFinished", "_this call ttt_amp_kf_fnc_tractorAtPlane"]
	];

	private _curvesData = [
	    [ // curve1
	    	[_tractor], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 3],
	            ["TimeInSeconds", true]
	        ],
	        _keysData
	    ]
	];

	private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
	if (isNull _group) then {
		_group = createGroup [sideLogic, true];
		_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
	};

	_timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
	_timeline setVariable ["ttt_amp_carrier", _carrier];
	_timeline setVariable ["ttt_amp_tractor", _tractor];
	_timeline setVariable ["ttt_amp_cart", _cart];
	_timeline setVariable ["ttt_amp_parkingPos", _pp];
	[_timeline] call BIS_fnc_timeline_play;
	_tractor animateSource ["wheel_rot_source", 1e12];
	_cart animateSource ["wheel_rot_source", 1e12];
	createVehicleCrew _tractor;

	_timeline
};

ttt_amp_kf_fnc_tractorAtPlane = {
	params ["_timeline"];
	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _tractor = _timeline getVariable "ttt_amp_tractor";
	private _cart = _timeline getVariable "ttt_amp_cart";
	private _pp = _timeline getVariable "ttt_amp_parkingPos";

	_tractor animateSource ["wheel_rot_source", 0, true];
	_cart animateSource ["wheel_rot_source", 0, true];

	private _planeArr = _pp nearEntities [["Air"], 5];
	if (count _planeArr != 1) exitWith {
		"None or too many planes found" call bis_fnc_error;
		[_carrier, _tractor, _cart] spawn ttt_amp_kf_fnc_returnToStart;
	};
	private _plane = _planeArr select 0;

	_plane engineOn false;
	[_cart, 1.5] spawn ttt_amp_kf_fnc_loadCart;
	[_plane, 1] spawn ttt_amp_kf_fnc_clearPlane;
	[_carrier, _tractor, _cart] spawn ttt_amp_kf_fnc_returnToStart;
};

ttt_amp_kf_fnc_clearPlane = {
	params ["_plane", ["_delay", 1]];
	{
		_plane setPylonLoadOut [_x, "", true];
		sleep _delay;
		// hard coded for F/A-18
	} forEach ["pylon1", "pylon2", "pylon3", "pylon4", "pylon5", "pylon6", "pylon7", "pylon8", "pylon9", "pylon10", "pylon11"];
	sleep 1;
};

ttt_amp_kf_fnc_loadCart = {
	params ["_cart", ["_delay", 5]];
	{
		_cart animateSource [_x , 0];
		sleep _delay;
	} forEach [ "m2", "m3", "m1", "m4", "m5", "m7", "m6", "m8"];
	_cart;	
};

ttt_amp_kf_fnc_unloadCart = {
	params ["_cart", ["_delay", 5]];
	{
		_cart animateSource [_x , 1];
		sleep _delay;
	} forEach [ "m8", "m6", "m7", "m5", "m4", "m1", "m2", "m3"];
	_cart;
};

ttt_amp_kf_fnc_returnToStart = {
	params ["_carrier", "_tractor", "_cart"];

	sleep 15;
	
	[_carrier getVariable "JDG_carrier_hangar_1", 2] spawn ttt_fnc_elevator;

	private _weaponsElevator = [_carrier, "E5Bottom"] call ttt_amp_kf_fnc_getMemPointNimitz;
	private _weapEleUnload = _weaponsElevator getPos [8, getDir _carrier + 90];
	_weapEleUnload set [2, (getPosASL _carrier select 2) + 17.441];

	private _turnPoint = _tractor getPos [7, getDir _carrier + 45];
	_turnPoint set [2, (getPosASL _carrier select 2) + 17.441];
	private _turnPointArriveVector = [vectorDir _carrier select 1, (vectorDir _carrier select 0) * -1, 0] vectorMultiply -1;

	private _time_1 = (_tractor distance _turnPoint) / 2;
	private _time_2 = _time_1 + (_turnPoint distance _weapEleUnload) / 3;

	private _keysData = [
		[	
			0,
			getPosASL _tractor,
			[
				vectorDir _tractor,
				[0,0,1]
			],
			[
				["Time", 0],
				["LeaveTangent", vectorDir _tractor],
				["LeaveTangentWeight", 100],
				["InterpMode", 1]
			]
		],
		[
			1,
			_turnPoint,
			[
				(vectorDir _carrier) vectorMultiply -1,
				[0,0,1] 
			],
			[
				["Time", _time_1],
				["ArriveTangent", _turnPointArriveVector],
				["ArriveTangentWeight", 50],
				["LeaveTangent", (vectorDir _carrier) vectorMultiply -1],
				["LeaveTangentWeight", 50],
				["InterpMode", 1]
			]
		],
		[
			2,
			_weapEleUnload,
			[
				(vectorDir _carrier) vectorMultiply -1,
				[0,0,1]
			],
			[
				["Time", _time_2],
				["ArriveTangent", vectorDir _carrier],
				["ArriveTangentWeight", 100],
				["InterpMode", 0]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", _time_2],
	    ["Loop", false],
		["InterpMode", 0],
		["EventFinished", "_this call ttt_amp_kf_fnc_tractorUnload"]
	];

	private _curvesData = [
	    [ // curve1
	    	[_tractor], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 3],
	            ["TimeInSeconds", true]
	        ],
	        _keysData
	    ]
	];

	private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
	if (isNull _group) then {
		_group = createGroup [sideLogic, true];
		_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
	};

	_timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
	_timeline setVariable ["ttt_amp_carrier", _carrier];
	_timeline setVariable ["ttt_amp_tractor", _tractor];
	_timeline setVariable ["ttt_amp_cart", _cart];
	[_timeline] call BIS_fnc_timeline_play;
	_tractor animateSource ["wheel_rot_source", 1e12];
	_cart animateSource ["wheel_rot_source", 1e12];
	_timeline

};

ttt_amp_kf_fnc_tractorUnload = {
	params ["_timeline"];

	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _tractor = _timeline getVariable "ttt_amp_tractor";
	private _cart = _timeline getVariable "ttt_amp_cart";

	_tractor animateSource ["wheel_rot_source", 0, true];
	_cart animateSource ["wheel_rot_source", 0, true];

	[_cart, 1] spawn ttt_amp_kf_fnc_unloadCart;
	[_carrier, _tractor, _cart] spawn ttt_amp_kf_fnc_returnToParking;
};

ttt_amp_kf_fnc_returnToParking = {
	params ["_carrier", "_tractor", "_cart"];


	sleep 10;
	[_carrier getVariable "JDG_carrier_hangar_1", 3] spawn ttt_fnc_elevator;
	private _startPos = _tractor getVariable "ttt_amp_startPos";

	_tractor animateSource ["wheel_rot_source", -1e12];
	_cart animateSource ["wheel_rot_source", -1e12];

	while {abs(getDir _tractor - (getDir _carrier -90)) > 1} do {
		_tractor setDir (getDir _tractor + 0.2);
		sleep 0.05;
	};
	private _time_1 = _tractor distance _startPos;
	private _keysData = [
		[	
			0,
			getPosASL _tractor,
			[
				vectorDir _tractor,
				[0,0,1]
			],
			[
				["Time", 0],
				["LeaveTangent", (vectorDir _tractor) vectorMultiply -1],
				["LeaveTangentWeight", 100],
				["InterpMode", 0]
			]
		],
		[
			1,
			_startPos,
			[
				(vectorDir _tractor) vectorMultiply -1,
				[0,0,1] 
			],
			[
				["Time", _time_1],
				["ArriveTangent", vectorDir _tractor],
				["ArriveTangentWeight", 50],
				["InterpMode", 0]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", _time_1],
	    ["Loop", false],
		["InterpMode", 0],
		["EventFinished", "_this call ttt_amp_kf_fnc_tractorPark"]
	];

	private _curvesData = [
	    [ // curve1
	    	[_tractor], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 0],
	            ["TimeInSeconds", true]
	        ],
	        _keysData
	    ]
	];

	private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
	if (isNull _group) then {
		_group = createGroup [sideLogic, true];
		_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
	};

	_timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
	_timeline setVariable ["ttt_amp_carrier", _carrier];
	_timeline setVariable ["ttt_amp_tractor", _tractor];
	_timeline setVariable ["ttt_amp_cart", _cart];
	[_timeline] call BIS_fnc_timeline_play;
	_timeline
};

ttt_amp_kf_fnc_tractorPark = {
	params ["_timeline"];

	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _tractor = _timeline getVariable "ttt_amp_tractor";
	private _cart = _timeline getVariable "ttt_amp_cart";

	_tractor animateSource ["wheel_rot_source", 0, true];
	_cart animateSource ["wheel_rot_source", 0, true];
	detach _cart;
	deleteVehicleCrew _tractor;

};